class Team:
    def __init__(self):
        self.teammembers = []
        self.waiting = []  #waiting to join the team
        self.ready = []  #Ready to go
        self.resources = []
        self.location = 0
        self.direction = 1
        self.triptime = 0

import random


def runmission(team,dir,dist):
    dist = len(team.teammembers)/2
    while 1:
        #do random thing
        if not team.teammembers:
            return
        func = random.choice([foundresources,foundresources, lost, coughtsickness, attack, nothing, nothing, nothing])
        func(team)
        if team.location == dist:
            team.direction = -1
        if team.location < 0:
            break
            
        team.location += team.direction
        team.triptime += 1
        print team.location
    print team.teammembers, team.resources, team.triptime


def foundresources(team):
    func = random.choice([foundmetal, foundmetal, foundfuel, foundfuel, foundfuel, foundlotfuel, foundlotsmetal])
    func(team)

def foundmetal(team):
    team.resources.append("metal")
    print team.resources
    team.triptime += 1
    
def foundfuel(team):
    for i in range(random.randint(1,2)):
        team.resources.append("fuel")
    print team.resources
    team.triptime += 1

def foundlotfuel(team):
    for i in range(random.randint(3,5)):
        team.resources.append("fuel")
    print team.resources
    team.triptime += 1

def foundlotsmetal(team):
    for i in range(random.randint(2,4)):
        team.resources.append("metal")
    print team.resources
    team.triptime += 1
    
def coughtsickness(team):
    m = len([x for x in team.teammembers if x == "medic"])
    sick = random.randint(6,8)
    for i in range(random.randint(0,3)):
        if not team.teammembers: break
        if m:
            m -= 1
            if random.randint(5,10) > sick:
                print "A medic cured the sickness"
                continue
            else:
                r = random.choice(team.teammembers)
                team.teammembers.remove(r)
                print r, "died from the sickness"
    print team.teammembers
    team.triptime += 1
    
def attack(team):
    g = len([x for x in team.teammembers if x == "guard"])
    p = len([x for x in team.teammembers])/2
    if p < 5:
        p = 5
    attackers = random.randint(5,p)
    if attackers <= g:
        print"the attack was fought off"
    else:
        dif = attackers - g
        for i in range(random.randint(1,dif)):
            if not team.teammembers: break
            r = random.choice(team.teammembers)
            if r == "guard":
                chance = 7
            else: chance = 3
            if random.randint(1,10) > chance:
                team.teammembers.remove(r)
                print r, "was killed by the attackers"
            else:
                print r, "was able to fight off the attacker"
    team.triptime += 1

def lost(team):
    dayslost = random.randint(1,4)
    trail = random.randint(3,6)
    e = len([x for x in team.teammembers if x == "explorer"])
    if e:
        e-= 1
        if random.randint(4,7) > trail:
            dayslost -= 1
            if dayslost <= 0:
                print "your explorers were able to find there way out"
            if dayslost >0:
                print "your away team lost there way, but found a way out after", dayslost, "day(s)"
    else:
        print "your away team lost there way, but found a way out after", dayslost, "day(s)"
    team.triptime += dayslost
    

def nothing(team):
    print "it was a uneventful day"

    
    

if __name__ == "__main__":
    team = Team()
    team.teammembers = ["explorer","explorer","explorer","explorer","medic","medic","medic","medic","medic","guard","guard","guard","guard","guard","carrier","carrier","carrier","carrier","carrier"]
    runmission(team,1,10)
